--[[todo

testing
	assist sprees
	hero
	spawn spree (help a teammate up)

code
	first strike consistency fix
	counter for times medal streak looped

--]]


HaloAnnouncer = HaloAnnouncer or {}
if HaloAnnouncerCore then 
	HaloAnnouncer._mod_path = HaloAnnouncerCore:GetPath()
else
	HaloAnnouncer._mod_path = ModPath
end
HaloAnnouncer._save_file_name = "killstreak_announcer_save.json"
HaloAnnouncer._config_file_name = "killstreak_announcer_config.ini"
HaloAnnouncer._save_path = SavePath .. HaloAnnouncer._save_file_name
HaloAnnouncer._menu_path = HaloAnnouncer._mod_path .. "menu/options.json"
HaloAnnouncer._config_path = SavePath .. HaloAnnouncer._config_file_name
HaloAnnouncer._assets_path = HaloAnnouncer._mod_path .. "assets/"
HaloAnnouncer._announcer_path = HaloAnnouncer._assets_path .. "snd/announcer/"
HaloAnnouncer._default_localization_path = HaloAnnouncer._mod_path .. "localization/english.json"
HaloAnnouncer._animator = nil

HaloAnnouncer._logs = {}
HaloAnnouncer.HUD_VALUES = {
	SAFE_MODE = false,
	MEDAL_ATLAS_TEXTURE = "guis/textures/halo_medals/medal_atlas",
	MEDAL_ATLAS_ICON_W = 90,
	MEDAL_ATLAS_ICON_H = 90,
	KILLFEED_LIFETIME = 5,
	MULTIKILL_THRESHOLD = 1.5,
	MEDAL_ICON_SIZE = 32,
	MEDAL_ICON_START_X = 64,
	MEDAL_ICON_START_Y = 400,
	MEDAL_ICON_END_X = 64,
	MEDAL_ICON_END_Y = 400,
	MEDAL_ICON_ANIMATE_NEW_PULSE_DURATION = 0.3,
	MEDAL_ICON_ANIMATE_NEW_PULSE_SCALE = 1.5,
	MEDAL_ICON_ANIMATE_NEW_TWIRL_DURATION = 0.25,
	MEDAL_ICON_START_ANGLE = 180,
	MEDAL_ICON_ANIMATE_NEW_TWIRL_ANGLE = 180,
	KILLFEED_TEXT_FONT_SIZE = 16,
	KILLFEED_TEXT_START_X = 100,
	KILLFEED_TEXT_START_Y = 420,
	KILLFEED_TEXT_END_X = 100,
	KILLFEED_TEXT_END_Y = 430,
	KILLFEED_TEXT_FONT_NAME = tweak_data.hud_players.ammo_font,
	KILLFEED_TEXT_FONT_SIZE = 16,
	KILLFEED_TEXT_ALPHA = 0.9,
	KILLFEED_TEXT_ANIMATE_NEW_DURATION = 0.3,
	COLOR_HUD_TEXT_BLUE = "64b2ff",
	COLOR_HUD_TEXT_FLASH = "feefef",
	ASSIST_DAMAGE_PERCENT_THRESHOLD = 0.4,
	ASSIST_TIMER_THRESHOLD = 5,
	EASTER_EGG_MEDALS_ENABLED = true,
	EASTER_EGG_MEDAL_1_ENABLED = true, --trans rights ( [x]% chance to proc when above a spree of at least [y] )
	EASTER_EGG_MEDAL_1_SPREE_THRESHOLD = 5,
	EASTER_EGG_MEDAL_1_CHANCE = 0.001, -- 0.1%
	EASTER_EGG_MEDAL_2_ENABLED = true, --no maidens ( procs when you use a doctor bag with [x] or fewer downs used )
	EASTER_EGG_MEDAL_2_DOWNS_THRESHOLD = 1,
	EASTER_EGG_MEDAL_2_CHANCE = 1, -- 100%
	EASTER_EGG_MEDAL_3_ENABLED = true, -- skill issue ( [x]% chance to proc any time you are incapacitated (eg by a taser/cloaker), not to be confused with downed )
	EASTER_EGG_MEDAL_3_CHANCE = 0.001 -- 0.1%
}

HaloAnnouncer.updater_id = "halo_announcer_update"

HaloAnnouncer._medal_data = {
	first = {
		name = "first",
		multiplier = 2.0,
		sfx = "first_strike",
		show_text = true,
		icon_xy = {1,0}
	},
	headshot = {
		name = "headshot",
		multiplier = 1.25,
		sfx = false,
		show_text = false,
		icon_xy = {1,1}
	},
	assist = {
		name = "assist",
		sfx = false,
		icon_xy = {3,0}
	},
	pummel = {
		name = "pummel",
		sfx = false,
		show_text = false,
		icon_xy = {1,2}
	},
	assassination = { --stealth
		name = "assassin",
		multiplier = 1.25,
		show_text = false,
		sfx = false,
		icon_xy = {1,3}
	},
	beatdown = { --from behind
		name = "beatdown",
		show_text = false,
		sfx = false,
		icon_xy = {1,4}
	},
	close_call = {
		name = "close_call",
		show_text = true,
		sfx = false,
		icon_xy = {1,5}
	},
	revenge = {
		name = "revenge",
		show_text = true,
		sfx = "revenge",
		icon_xy = {1,6}
	},
	avenger = { --not able to implement; kill a cloaker or taser who incapped a teammate, or kill an enemy who downed a teammate
		name = "avenger",
		show_text = false,
		sfx = false,
		icon_xy = {1,7}
	},
	grave = {
		name = "grave",
		show_text = true,
		sfx = false,
		icon_xy = {1,8}
	},
	extermination = { --not implemented
		name = "extermination",
		show_text = true,
		disabled = true,
		sfx = "extermination",
		icon_xy = {0,9} --this is not the right icon
	},
	sniper = {
		name = "sniper", --headshot only
		sfx = false,
		show_text = false,
		icon_xy = {4,0}
	},
	firebird = {
		name = "firebird",
		sfx = false,
		show_text = true,
		icon_xy = {5,0}
	},
	bulltrue = {
		name = "bulltrue",
		sfx = false,
		show_text = true,
		icon_xy = {5,1}
	},
	headcase = {
		name = "headcase",
		sfx = false,
		show_text = false,
		icon_xy = {5,2}
	},
	reload_this = {
		name = "reload_this",
		sfx = false,
		show_text = true,
		icon_xy = {6,3}
	},
	moa = {
		name = "moa",
		sfx = false,
		show_text = false,
		icon_xy = {7,3}
	},
	pull = {
		name = "pull",
		sfx = false,
		show_text = true,
		icon_xy = {5,3}
	},
	hero = { --survive an assault where there is at least one other player-controlled character in the game, but you are the only player-controlled character not in custody/downed
		name = "hero",
		sfx = false,
		show_text = true,
		icon_xy = {5,4}
	},
	protector = { --not implemented; on res?
		name = "protector",
		sfx = false,
		show_text = true,
		icon_xy = {5,5}
	},
	showstopper = {
		name = "showstopper",
		sfx = false,
		show_text = false,
		icon_xy = {5,6}
	},
	skyjack = { --not implemented
		name = "skyjack",
		sfx = false,
		show_text = false,
		icon_xy = {5,5}
	},
	seek_and_destroy = { --not implemented
		name = "seek",
		sfx = false,
		show_text = false,
		icon_xy = {5,8}
	},
	splatter = {
		name = "splatter",
		multiplier = 1,
		sfx = false,
		show_text = false,
		icon_xy = {6,0}
	},
	wheelman = {
		name = "wheelman",
		show_text = false,
		sfx = false,
		icon_xy = {1,9},
		suffix = ""
	},
	last_man_standing = { --not implemented
		name = "last_man",
		sfx = "last_man_standing",
		show_text = false,
		icon_xy = {5,9}
	},
	betrayal = {
		name = "betrayal",
		sfx = "betrayal", --betrayal, suicide, and betrayed are only in the medals table so that its sound file will be loaded at the same time as all the others
		icon_xy = {-1,-1},
		show_text = false,
		suffix = ""
	},
	suicide = {
		name = "suicide",
		sfx = "suicide",
		icon_xy = {-1,-1},
		show_text = false
	},
	round_over = {
		name = "round_over",
		sfx = "round_over",
		icon_xy = {-1,-1},
		show_text = false
	},
	game_over = {
		name = "game_over",
		sfx = "game_over",
		icon_xy = {-1,-1},
		show_text = false
	},
	betrayed = {
		name = "betrayed",
		sfx = "betrayed",
		icon_xy = {-1,-1},
		show_text = false
	},
	trans_rights = {
		name = "trans_rights",
		sfx = "trans_rights",
		icon_xy = {7,7}, 
		show_text = true
	},
	no_maidens = {
		name = "no_maidens",
		sfx = "no_maidens",
		icon_xy = {7,8},
		show_text = true
	},
	skill_issue = {
		name = "skill_issue",
		sfx = "skill_issue",
		icon_xy = {7,9},
		show_text = true
	},
	multikill = {
		[2] = {
			name = "multi_2",
			multiplier = 1.2,
			sfx = "multikill_2",
			show_text = true,
			hold_sfx = true,
			icon_xy = {0,0}
		},
		[3] = {
			name = "multi_3",
			multiplier = 1.3,
			sfx = "multikill_3",
			show_text = true,
			hold_sfx = true,
			icon_xy = {0,1}
		},
		[4] = {
			name = "multi_4", --obligatory joke here
			multiplier = 1.4,
			sfx = "multikill_4",
			show_text = true,
			hold_sfx = true,
			icon_xy = {0,2}
		},
		[5] = {
			name = "multi_5",
			multiplier = 1.5,
			sfx = "multikill_5",
			show_text = true,
			hold_sfx = true,
			icon_xy = {0,3}
		},
		[6] = {
			name = "multi_6",
			multiplier = 1.6,
			sfx = "multikill_6",
			show_text = true,
			hold_sfx = true,
			icon_xy = {0,4}
		},
		[7] = {
			name = "multi_7",
			multiplier = 1.7,
			sfx = "multikill_7",
			show_text = true,
			hold_sfx = true,
			icon_xy = {0,5}
		},
		[8] = {
			name = "multi_8",
			multiplier = 1.8,
			sfx = "multikill_8",
			show_text = true,
			hold_sfx = true,
			icon_xy = {0,6}
		},
		[9] = {
			name = "multi_9",
			multiplier = 1.9,
			sfx = "multikill_9",
			show_text = true,
			hold_sfx = true,
			icon_xy = {0,7}
		},
		[10] = {	
			name = "multi_10",
			multiplier = 2.0,
			sfx = "multikill_10",
			show_text = true,
			hold_sfx = true,
			icon_xy = {0,8}
		}
	},
	spree_all = {		
		[10] = {
			name = "spree_all_1",
			sfx = "spree_all_1",
			show_text = true,
			hold_sfx = true,
			multiplier = 1.1,
			icon_xy = {2,0}
		},
		[20] = {
			name = "spree_all_2",
			sfx = "spree_all_2",
			show_text = true,
			hold_sfx = true,
			multiplier = 1.2,
			icon_xy = {2,1}
		},
		[30] = {
			name = "spree_all_3",
			sfx = "spree_all_3",
			show_text = true,
			hold_sfx = true,
			multiplier = 1.25,
			icon_xy = {2,2}
		},
		[40] = {
			name = "spree_all_4",
			sfx = "spree_all_4",
			show_text = true,
			hold_sfx = true,
			multiplier = 1.3,
			icon_xy = {2,3}
		},
		[50] = {
			name = "spree_all_5",
			sfx = "spree_all_5",
			show_text = true,
			hold_sfx = true,
			multiplier = 1.35,
			icon_xy = {2,4}
		},
		[100] = {
			name = "spree_all_6",
			sfx = "spree_all_6",
			show_text = true,
			hold_sfx = true,
			multiplier = 1.4,
			icon_xy = {2,5}
		},
		[500] = {
			name = "spree_all_7",
			sfx = "spree_all_7",
			show_text = true,
			hold_sfx = true,
			multiplier = 1.45,
			icon_xy = {2,6}
		},
		[1000] = {				
			name = "spree_all_8",
			sfx = "spree_all_8",
			show_text = true,
			hold_sfx = true,
			multiplier = 1.5,
			icon_xy = {2,7}
		}
	},
	spree_assist = {
		[5] = {	
			name = "spre_assist_1",
			sfx = "spree_assist_1",
			show_text = true,
			hold_sfx = true,
			multiplier = 1.1,
			icon_xy = {3,1}
		},
		[10] = {
			name = "spre_assist_2",
			sfx = "spree_assist_2",
			show_text = true,
			hold_sfx = true,
			multiplier = 1.15,
			icon_xy = {3,2}
		},
		[15] = {
			name = "spre_assist_3",
			sfx = "spree_assist_3",
			show_text = true,
			hold_sfx = true,
			multiplier = 1.2,
			icon_xy = {3,3}
		}
	},
	spree_sword = { --on sharp melee kill
		[5] = {
			name = "spree_sword_1",
			sfx = "spree_sword_1",
			hold_sfx = true,
			show_text = true,
			multiplier = 1.25,
			icon_xy = {3,4}
		},
		[10] = {
			name = "spree_sword_2",
			sfx = "spree_sword_2",
			hold_sfx = true,
			show_text = true,
			multiplier = 1.5,
			icon_xy = {3,5}
		},
		[15] = {
			name = "spree_sword_3",
			sfx = "spree_sword_3",
			hold_sfx = true,
			show_text = true,
			multiplier = 1.75,
			icon_xy = {3,6}
		}
	},
	spree_grenade = {
		[5] = {
			name = "spree_grenade_1",
			sfx = "spree_grenade_1",
			hold_sfx = true,
			icon_xy = {3,7}
		},
		[10] = {
			name = "spree_grenade_2",
			sfx = "spree_grenade_2",
			hold_sfx = true,
			icon_xy = {3,8}
		},
		[15] = {
			name = "spree_grenade_3",
			sfx = "spree_grenade_3",
			hold_sfx = true,
			icon_xy = {3,9}
		}
	},
	spree_sniper = {
		[5] = {
			name = "spree_sniper_1",
			sfx = "spree_sniper_1",
			hold_sfx = true,
			icon_xy = {4,1}
		},
		[10] = {
			name = "spree_sniper_2",
			sfx = "spree_sniper_2",
			hold_sfx = true,
			icon_xy = {4,2}
		},
		[15] = {
			name = "spree_sniper_3",
			sfx = "spree_sniper_3",
			hold_sfx = true,
			icon_xy = {4,3}
		}
	},
	spree_shotgun = {
		[5] = {
			name = "spree_shotgun_1",
			sfx = "spree_shotgun_1",
			hold_sfx = true,
			icon_xy = {4,4}
		},
		[10] = {
			name = "spree_shotgun_2",
			sfx = "spree_shotgun_2",
			hold_sfx = true,
			icon_xy = {4,5}
		},
		[15] = {
			name = "spree_shotgun_3",
			sfx = "spree_shotgun_3",
			hold_sfx = true,
			icon_xy = {4,6}
		}
	},
	spree_splatter = {
		[5] = {
			name = "spree_splatter_1",
			sfx = "spree_splatter_1",
			show_text = true,
			hold_sfx = true,
			icon_xy = {4,7}
		},
		[10] = {
			name = "spree_splatter_2",
			sfx = "spree_splatter_2",
			show_text = true,
			hold_sfx = true,
			icon_xy = {4,8}
		},
		[15] = {
			name = "spree_splatter_3",
			sfx = "spree_splatter_3",
			show_text = true,
			hold_sfx = true,
			icon_xy = {4,9}
		}
	},
	spree_wheelman = {
		[5] = { --couldn't find the icons for these, but i know they exist somewhere
			name = "spree_wheelman_1",
			show_text = true,
			hold_sfx = true,
			sfx = "spree_wheelman_1",
			icon_xy = {1,9}
		},
		[10] = {
			name = "spree_wheelman_2",
			show_text = true,
			hold_sfx = true,
			sfx = "spree_wheelman_2",
			icon_xy = {1,9}
		},
		[15] = {
			name = "spree_wheelman_3",
			show_text = true,
			hold_sfx = true,
			sfx = "spree_wheelman_3",
			icon_xy = {1,9}
		}
	},
	spree_spawn = { --not implemented; help a teammate up
		[5] = {
			name = "spree_spawn_1",
			sfx = "spree_spawn_1",
			hold_sfx = false,
			icon_xy = {6,4}
		},
		[10] = {
			name = "spree_spawn_2",
			sfx = "spree_spawn_2",
			hold_sfx = false,
			icon_xy = {6,5}
		},
		[15] = {
			name = "spree_spawn_3",
			sfx = "spree_spawn_3",
			hold_sfx = false,
			icon_xy = {6,6}
		}
	},
	spree_hammer = {
		[5] = {
			name = "spree_hammer_1",
			sfx = "spree_hammer_1",
			hold_sfx = true,
			icon_xy = {6,7}
		},
		[10] = {
			name = "spree_hammer_2",
			sfx = "spree_hammer_2",
			hold_sfx = true,
			icon_xy = {6,8}
		},
		[15] = {
			name = "spree_hammer_3",
			sfx = "spree_hammer_3",
			hold_sfx = true,
			icon_xy = {6,9}
		}
	}
}

for medal_id,medal_data in pairs(HaloAnnouncer._medal_data) do 
	if type(medal_data) == "table" then
		local max_threshold = 0
		for kill_threshold,tiered_medal_data in pairs(medal_data) do 
			if type(kill_threshold) == "number" then
				if kill_threshold > max_threshold then
					max_threshold = kill_threshold
				end
			else
				break
			end
		end
		if medal_data[max_threshold] then
			medal_data[max_threshold].is_max_tier = true
		end
	end
end


HaloAnnouncer.settings = {
	sound_volume = 0.5,
	hud_compatibility_mode = true,
	announcer_sounds_enabled = true,
	announcer_frantic_enabled = false,
	killstreak_medals_enabled = true,
	killstreak_loop_enabled = false,
	killfeed_force_all_messages = false,
	killfeed_medal_message_display_mode = 2, --1: always on; 2: unchanged (use medal data); 3: off
	grunt_birthday_mode = 2 --1: always on; 2: special occasions (april fools, bungie day/halo's birthday/payday 2's birthday); 3: off
}

HaloAnnouncer._panel = nil
HaloAnnouncer._killfeed_panel = nil

HaloAnnouncer.KILLS_CACHE_TEMPLATE = {
	last_kill_t = 0,
	
	first = false,
	spree_count = 0,
	multi_count = 0,
	assist_count = 0,
	revives_count = 0,
	vehicle = 0,
	vehicle_assist = 0,
	melee = 0,
	sniper = 0,
	shotgun = 0,
	close_call = false,
	grenade = 0
}
HaloAnnouncer.has_done_first_strike = false
HaloAnnouncer._killers = {}

HaloAnnouncer._kills_cache = table.deep_map_copy(HaloAnnouncer.KILLS_CACHE_TEMPLATE)

HaloAnnouncer.num_killfeed_messages = 0
HaloAnnouncer.killfeed = {}
HaloAnnouncer.killfeed_icons = {}
HaloAnnouncer.newest_killfeed = nil

HaloAnnouncer.previous_sound_id = nil --string
HaloAnnouncer._sounds_queue = {
	--[[
		"sound_name_here"
	--]]
}

HaloAnnouncer._sounds = {
--ex:
--	["first_strike"] = "Halo Killstreaks/assets/snd/announcer/first_strike.ogg" 
}
HaloAnnouncer._all_sounds = {}
HaloAnnouncer._announcer_sound_source = nil

HaloAnnouncer._active_skulls = {}

HaloAnnouncer.num_medals = 0
HaloAnnouncer.newest_medal = nil

-- Utils/Getters

function HaloAnnouncer:log(...)
	if _G.Log then 
		Log(...)
	end
	table.insert(self._logs,#self._logs+1,{...})
end

function HaloAnnouncer:GetMedalIcon(x,y)
	local hud_values = self.HUD_VALUES
	local texture = hud_values.MEDAL_ATLAS_TEXTURE
	local w = hud_values.MEDAL_ATLAS_ICON_W
	local h = hud_values.MEDAL_ATLAS_ICON_H
	
	return texture,{
		x * w,y * h,w,h
	}
end

function HaloAnnouncer:CreateHUD(parent)

	if alive(self._panel) then 
		self._panel:parent():remove(self._panel) 
		self._panel = nil
	end

	local should_create_new_workspace = self.settings.hud_compatibility_mode
	if not alive(parent) then
		should_create_new_workspace = true
	end
	if should_create_new_workspace then 
		self._ws = alive(self._ws) and self._ws or managers.gui_data:create_fullscreen_workspace()
		parent = self._ws:panel()
	end
	
	
	local halo_announcer_parent_panel = parent:panel({
		name = "halo_announcer_parent_panel"
	})
	self._panel = halo_announcer_parent_panel
	
	self._killfeed_panel = halo_announcer_parent_panel:panel({
		name = "killfeed"
	})
end

function HaloAnnouncer:GetMultikillTime()
	return self.HUD_VALUES.MULTIKILL_THRESHOLD
end

function HaloAnnouncer.interp_colors(one,two,percent) --interpolates colors based on a percentage
--percent is [0,1]
	percent = math.clamp(percent,0,1)
	
--color 1
	local r1 = one.red
	local g1 = one.green
	local b1 = one.blue
	local a1 = one.alpha
	
--color 2
	local r2 = two.red
	local g2 = two.green
	local b2 = two.blue
	local a2 = two.alpha

--delta
	local r3 = r2 - r1
	local g3 = g2 - g1
	local b3 = b2 - b1
	local a3 = a2 - a1
	
	return Color(r1 + (r3 * percent),g1 + (g3 * percent), b1 + (b3 * percent)):with_alpha(a1 + (a3 * percent))
end

function HaloAnnouncer:IsAnnouncerEnabled()
	return self.settings.announcer_sounds_enabled
end

function HaloAnnouncer:IsKillstreakMedalsEnabled()
	return self.settings.killstreak_medals_enabled
end

function HaloAnnouncer:IsAnnouncerFranticEnabled()
	return self.settings.announcer_frantic_enabled
end

function HaloAnnouncer:IsSkullActive(skull_name)
	return self._active_skulls[skull_name]
end

function HaloAnnouncer:IsSafeMode() --disables vehicledrivingext hooks
	return self.HUD_VALUES.SAFE_MODE
end

function HaloAnnouncer:GetMedalMessageDisplayMode() 
	return self.settings.killfeed_medal_message_display_mode 
end

function HaloAnnouncer:IsKillstreakLoopEnabled()
	return self.settings.killstreak_loop_enabled
end

function HaloAnnouncer:GetSoundVolume()
	return self.settings.sound_volume
end

function HaloAnnouncer:OnAssaultEnd()
	local player = managers.player:local_player()
	if alive(player) then 
		local num_players = 0
		for id,data in pairs(managers.criminals._characters) do 
			if data.taken and not data.data.ai then 
				if data.unit ~= player then
					num_players = num_players + 1
					
					if alive(data.unit) then
						local movement_ext = data.unit:movement()
						local state_name = movement_ext and movement_ext:current_state_name()
						
						local dead_states = {
							"arrested",
							"dead",
							"bleed_out",
							"fatal",
							"incapacitated"
						}
						
						if state_name and not dead_states[state_name] then
							return
						end
						
						--else, teammate is either in custody,
						--or not loaded in (which would still qualify the player as the last one standing) 
					end
					
				end
			end
		end
		if num_players > 1 then 
			self:AddMedal("hero")
		end
	
--		local num_players = managers.criminals:get_num_player_criminals()
--		local num_in_trade_queue = managers.trade:num_in_trade_queue()

	end
end

function HaloAnnouncer:OnReviveSuccess()
	self:AwardMedalProgress("spree_spawn","revives_count",1)
end

function HaloAnnouncer:Setup(force)
	
	managers.mission:add_global_event_listener("haloannouncer_on_assault_end",{"end_assault","end_assault_late"},callback(self,self,"OnAssaultEnd"))
	
	self:CheckActiveSkulls()
	
	if BeardLib then
		BeardLib:AddUpdater(self.updater_id,callback(self,self,"Update"))
	elseif managers.hud then 
		managers.hud:add_updator(self.updater_id,callback(self,self,"Update"))
	end

	if force or not self._setup_done then 
		self._setup_done = true
	else
		return
	end
	
    if blt.xaudio then
        blt.xaudio.setup()
		
		local function file_exists(snd)
			local path = self._announcer_path .. snd .. ".ogg"
			return SystemFS:exists( Application:nice_path(path,true) )
		end
		
		local function loadsound(snd)
			local path = self._announcer_path .. snd .. ".ogg"
			self._sounds[snd] = path --do not load into a buffer until it is time to play the sound
			table.insert(self._all_sounds,#self._all_sounds + 1,path)
		end

		--manually load this sound as a special exception since it is not a medal
		local grunt_birthday_path = self._announcer_path .. "grunt_birthday.ogg"
		self._sounds.grunt_birthday = grunt_birthday_path
		table.insert(self._all_sounds,#self._all_sounds + 1,grunt_birthday_path)
		
		for medal_name,medal in pairs(self._medal_data) do 
			local sfx_name = medal.sfx
			if sfx_name and sfx_name ~= "" and not medal.disabled then 
				if file_exists(sfx_name) then 
					loadsound(sfx_name)
				else
					self:log("No sound file exists by name " .. tostring(sfx_name))
				end
			else
				for tier,tiered_medal in pairs(medal) do 
					if type(tier) == "number" then 
						local tiered_sfx_name = tiered_medal.sfx
						if tiered_sfx_name and tiered_sfx_name ~= "" and not tiered_medal.disabled then 							
							if file_exists(tiered_sfx_name) then
								loadsound(tiered_sfx_name)
							else
								self:log("No tiered sound file exists by name " .. tostring(tiered_sfx_name))
							end
						end
					end
				end
			end
		end
	end
end

--Hooks:Add("BaseNetworkSessionOnLoadComplete","haloannouncer_on_load_complete",callback(HaloAnnouncer,HaloAnnouncer,"Setup"))

function HaloAnnouncer:CheckActiveSkulls()

	if self.settings.grunt_birthday_mode == 1 then 
		self._active_skulls.birthday = true
	elseif self.settings.grunt_birthday_mode == 2 then
		local day = os.date("%d")
		local month = os.date("%m")
		self._active_skulls.birthday = (day == "1" and month == "4") or (day == "7" and month == "7")
	else
		self._active_skulls.birthday = false
	end
	
end


do
	--load ini parser
	local f,e = blt.vm.loadfile(HaloAnnouncer._mod_path .. "utils/LIP.lua")
	local lip
	if e then 
		--error
	elseif f then 
		lip = f()
	end
	if lip then 
		HaloAnnouncer._lip = lip
	end
end



function HaloAnnouncer:Update(t,dt)
	if self._animator then
		self._animator:UpdateAnimate(t,dt)
	end
	
	
	local hud_values = self.HUD_VALUES

	local announcer = self._announcer_sound_source
	local sounds_queue = self._sounds_queue
	if not announcer or announcer:is_closed() then 
		local current_sound_id = self._sounds_queue[1]
		if current_sound_id then
			local new_sound_id = self._sounds[current_sound_id]
			if new_sound_id then 
			--[[
				local prev_sound_id = self.previous_sound_id
				if prev_sound_id and prev_sound_id ~= current_sound_id then
					local prev_buffer = announcer._buffer
					if prev_buffer then 
--							prev_buffer:close(true)
						self.previous_sound_id = nil
					end
				end
				
				self.previous_sound_id = current_sound_id
				local new_buffer = XAudio.Buffer:new(new_sound_id)
				announcer:set_buffer(new_buffer)
				announcer:play()
				self:log("Playing " .. tostring(new_sound_id))
--]]				
				announcer = XAudio.Source:new(XAudio.Buffer:new(new_sound_id))
				announcer:set_volume(self:GetSoundVolume())
				self._announcer_sound_source = announcer
				table.remove(self._sounds_queue,1)
			end
		end
	end
	
	local player = managers.player:local_player()
	local player_damage
	if player and alive(player) then
		player_damage = player:character_damage()
	
		--close call medal stuff
		if self:KillsCache("close_call") and player_damage:armor_ratio() >= 1 then 
			self:KillsCache("close_call",false,true)
			self:AddMedal("close_call")
		end
	
	
		--killfeed stuff
		local KILLFEED_LIFETIME = hud_values.KILLFEED_LIFETIME
		local killfeed_count = 0
		for i,item in pairs(self.killfeed) do
			killfeed_count = killfeed_count + 1
			if (t - item.start_t > (item.lifetime or KILLFEED_LIFETIME)) then
				if item.text and alive(item.text) then 
					self:animate(item.text,"animate_fadeout_linear",function (o) o:parent():remove(o) end,0.25)
--					item.text:parent():remove(item.text)
				end
				table.remove(self.killfeed,i)
--				self.killfeed[i] = nil
			else
				if item.text and alive(item.text) then 
					local ty1 = item.text:y()
					local ty2 = hud_values.KILLFEED_TEXT_END_Y + (killfeed_count * item.text:line_height())
					local tx1 = item.text:x()
					local tx2 = hud_values.KILLFEED_TEXT_END_X
					item.text:set_x(tx1 + ((tx2 - tx1) / 4))
					item.text:set_y(ty1 + ((ty2 - ty1) / 4))
				end
			end
		end
		
		killfeed_count = 0
		for i,item in pairs(self.killfeed_icons) do 
			killfeed_count = killfeed_count + 1
			if (t - item.start_t > KILLFEED_LIFETIME) then 
				if item.bitmap and alive(item.bitmap) then 
					self:animate(item.bitmap,"animate_fadeout_linear",function (o) o:parent():remove(o) end,0.25,nil,-item.bitmap:w(),false)
				end
				table.remove(self.killfeed_icons,i)
--				self.killfeed_icons[i] = nil
			else
				if item.bitmap and alive(item.bitmap) then 
					local bx1 = item.bitmap:x()
					local bx2 = hud_values.MEDAL_ICON_END_X + (killfeed_count * item.bitmap:h())
					local by1 = item.bitmap:y()
					local by2 = hud_values.MEDAL_ICON_END_Y
					item.bitmap:set_x(bx1 + ((bx2 - bx1) / 4))
					item.bitmap:set_y(by1 + ((by2 - by1) / 4))
				end
			end
		end
		
	end
	
end



--- Animator

HaloAnnouncer._animations = {
	animate_killfeed_text_in = function(o,t,dt,start_t,duration,font_size,color_1,color_2,...)
		duration = duration or 3
		font_size = font_size or 12
		local ratio = (t - start_t) * (1/duration)
		local sine = math.max(0,math.sin(math.deg(math.pi * ratio)))
		o:set_font_size((1 + sine) * font_size)
		o:set_color(HaloAnnouncer.interp_colors(color_1,color_2,sine))
		if start_t + duration < t then
			return true
		end
	end,
	animate_killfeed_icon_twirl = function(o,t,dt,start_t,duration,add_angle,x,y,...)
		duration = duration or 3
		add_angle = add_angle or 360
		local ratio = dt / duration
	--	o:set_center(x,y)
		if start_t + duration < t then
			return true
		else	
			o:set_rotation(o:rotation() + (ratio * add_angle))
		end
	end,
	animate_killfeed_icon_pulse = function(o,t,dt,start_t,duration,icon_size,pulse_multiplier,center_x,center_y,...)
		duration = duration or 0.25
		icon_size = icon_size or 24
		pulse_multiplier = (pulse_multiplier or 2) - 1
		
		local ratio = (t - start_t) * (1/duration)
		local sine = math.max(0,math.sin(math.deg(math.pi * ratio)))
		local size = icon_size * (1 + (pulse_multiplier * sine))
		if start_t + duration < t then 
			if center_x and center_y then 
				o:set_center(center_x,center_y)
			end
			o:set_size(icon_size,icon_size)
			return true
		else
			if center_x and center_y then 
				o:set_center(center_x,center_y)
			end
			o:set_size(size,size)
		end
	end,
	animate_fadeout_linear = function(o,t,dt,start_t,duration,start_alpha,exit_x,exit_y)
		start_alpha = start_alpha or 1
		duration = duration or 1
		local ratio = (t - start_t) / duration
		o:set_alpha(start_alpha * (1 - ratio))
		if exit_y then 
			o:set_y(o:y() + (exit_y * dt / duration))
		end
		if exit_x then 
			o:set_x(o:x() + (exit_x * dt / duration))
		end
		if ratio >= 1 then 
			return true
		end
	end
}

do
	--load and init QuickAnimate
	dofile(HaloAnnouncer._mod_path .. "utils/QuickAnimate.lua")
	
	HaloAnnouncer._animator = QuickAnimate:new("halo_announcer",{
		updater_type = QuickAnimate.updater_types.none,
		parent = HaloAnnouncer._animations
	})
end

function HaloAnnouncer:animate(...)
	return self._animator and self._animator:animate(...)
end

function HaloAnnouncer:animate_remove_done_cb(object,new)
	if self._animator then 
		local o = self._animator._animate_targets[tostring(object)]
		if o then 
			o.done_cb = new
			return true
		end
	end
	return false
end




-- Announcer Management

--queue a sound to play
function HaloAnnouncer:PlayAnnouncerSound(name)
	if not self:IsAnnouncerEnabled() then 
		return
	end

	local snd = self._sounds[name]
	if snd then 
--		XAudio.Source:new(XAudio.Buffer:new(snd))
		self._sounds_queue[#self._sounds_queue + 1] = name
	else
		self:log("PlayAnnouncerSound(): sound [" .. tostring(name) .. "] not found",{color = Color.red})
	end
end



-- Killfeed and Killstreak Management

--effectively replaces AddMedal() for tiered medals
function HaloAnnouncer:AwardMedalProgress(medal_category,kill_type,progress,params)
	local medal_data = self._medal_data[medal_category]

	if medal_data then 
	
		if progress then 
			local rank = self:KillsCache(kill_type,progress)
			
			if rank and medal_data[rank] and self:AddMedalFromData(medal_data[rank],medal_category,params) then
				if medal_data[rank].is_max_tier and self:IsKillstreakLoopEnabled() then
					self:KillsCache(kill_type,0,true)
				end	
			end
		else
			self:AddMedalFromData(medal_data,medal_category,params)
		end
	else
		self:log("ERROR: HaloAnnouncer:AwardMedalProgress(" .. tostring(kill_type) .. "," .. tostring(medal_category) .. "," .. tostring(progress) .. "," .. tostring(params) .. ") (bad medal [2])",{color = Color.red})
	end
end

function HaloAnnouncer:KillsCache(category,amount,set)
	if amount ~= nil then 
		if set then 
			self._kills_cache[category] = amount
		else
			amount = amount and tonumber(amount)
			if amount and type(self._kills_cache[category]) == "number" then 
				self._kills_cache[category] = self._kills_cache[category] + amount
			end
		end
	elseif set ~= nil then
		self:log("Error: No killcount category found for " .. tostring(category),{color = Color.red})
	end
	
	return self._kills_cache[category]
end

function HaloAnnouncer:ClearKillsCache()
	for k,v in pairs(self.KILLS_CACHE_TEMPLATE) do 
		self._kills_cache[k] = v
	end
--	HaloAnnouncer._kills_cache = table.deep_map_copy(HaloAnnouncer.KILLS_CACHE_TEMPLATE)

end

function HaloAnnouncer:RegisterKiller(unit,peer_id)
	local unit_key = alive(unit) and unit:key()
	if unit_key then 
		local killer_data
		if self._killers[unit_key] then 
			killer_data = self._killers[unit_key]
		else 
			killer_data = {
				defeated_player = nil,
				defeated_teammates = {}
			}
			self._killers[unit_key] = killer_data
		end
		
		local session = managers.network:session()
		local local_peer_id = session:local_peer():id()
		if peer_id == local_peer_id then 
			killer_data.defeated_player = true
		else
			local peer = session:peer(peer_id)
			if peer then 
				--rather than go through the trouble of storing the teammate peer_id and removing if the teammate leaves,
				--just store the name as it is now
				local peer_name = peer:name()
				if not table.contains(killer_data.defeated_teammates,peer_name) then 
					table.insert(killer_data.defeated_teammates,peer_name)
				end
			end
		end
		
		
	end
end

function HaloAnnouncer:UnregisterKiller(unit,unit_key)
	unit_key = unit_key or alive(unit) and unit:key()
	if unit_key then
		self._killers[unit_key] = nil
	end
end

--returns two arguments: bool,tbl containing string names of all players avenged (not technically feasible without networking)
function HaloAnnouncer:IsAvenging(unit,unit_key)
	unit_key = unit_key or alive(unit) and unit:key()
	if unit_key then
		local killer_data = self._killers[unit_key]
		if killer_data then 
			return #killer_data.defeated_teammates > 0,killer_data.defeated_teammates
		end
	end
	
	return false,{}
end

--returns bool
function HaloAnnouncer:IsRevenging(unit,unit_key) --grammatically correct/10
		
	unit_key = unit_key or alive(unit) and unit:key()
	if unit_key then
		local killer_data = self._killers[unit_key]
		if killer_data then 
			return killer_data.defeated_player
		end
	end
	
	return false
end

function HaloAnnouncer:AddKillfeedMessage(text,params)
	params = params or {}
	local killfeed = self._killfeed_panel
	self.num_killfeed_messages = self.num_killfeed_messages + 1
	
	local hud_values = self.HUD_VALUES
	
	local function add_text_to_killfeed (text_panel)
		self.newest_killfeed = nil
		table.insert(self.killfeed,1,{start_t = Application:time(),text = text_panel,lifetime = params.lifetime})
	end
	
	local label = killfeed:text({
		name = "label_" .. self.num_killfeed_messages,
		layer = 1,
		x = hud_values.KILLFEED_TEXT_START_X,
		y = hud_values.KILLFEED_TEXT_START_Y,
		text = text,
		color = Color.white,
		align = "left",
		font = params.font or hud_values.KILLFEED_TEXT_FONT_NAME,
		font_size = 0, --set to nonzero once it starts
		alpha = hud_values.KILLFEED_TEXT_ALPHA
	})
	if self.newest_killfeed and alive(self.newest_killfeed) then 
		self:animate_remove_done_cb(self.newest_killfeed)
--			function(o)
--				self:animate(o,"animate_killfeed_text_in",nil,0.3,16,self.color_data.hud_text_blue,self.color_data.hud_text_flash)
--			end
--		)
		table.insert(self.killfeed,1,{start_t = Application:time(),text = self.newest_killfeed})
	end
	self.newest_killfeed = label
	
	self:animate(label,"animate_killfeed_text_in",add_text_to_killfeed,params.duration or hud_values.KILLFEED_TEXT_ANIMATE_NEW_DURATION,params.font_size or hud_values.KILLFEED_TEXT_FONT_SIZE,params.color_1 or Color(hud_values.COLOR_HUD_TEXT_BLUE),params.color_2 or Color(hud_values.COLOR_HUD_TEXT_FLASH))
	return label
end

function HaloAnnouncer:OnEnemyShot(unit,attack_data)
	local player = managers.player:local_player()
	if attack_data.result and attack_data.result.type == "death" then
		if attack_data.attacker_unit and alive(attack_data.attacker_unit) then 
			if attack_data.attacker_unit == player then
				HaloAnnouncer:OnEnemyKilled(attack_data,nil,unit)
				
				local attack_damage = attack_data.damage
				if alive(unit) then
					local dmg_ext = unit:character_damage()
					if dmg_ext then 
						local total_damage = dmg_ext.haloannouncer_total_damage_dealt or 0
						total_damage = total_damage + attack_damage
						dmg_ext.haloannouncer_total_damage_dealt = total_damage
						dmg_ext.haloannouncer_last_damage_dealt_t = Application:time()
					end
				end
			elseif managers.groupai:state():all_criminals()[attack_data.attacker_unit:key()] then 
				HaloAnnouncer:OnTeammateKill(attack_data)
			end
		end
		HaloAnnouncer:UnregisterKiller(unit)
	end
end

function HaloAnnouncer:OnEnemyKilled(attack_data,headshot,unit,variant,player_weapon_id)
	local t = Application:time()
	local player = managers.player:local_player()
	
	local weapon_base
	if attack_data then
--		if (not player) or (attack_data.attacker_unit ~= managers.player:local_player()) then
--			return
--		end
		local player_weapon = attack_data.weapon_unit
		weapon_base = player_weapon and alive(player_weapon) and player_weapon:base()
	else
		return
	end
	attack_data = attack_data or {}
	headshot = headshot or attack_data.headshot
	
	
	local player_movement = player:movement()
	
	local player_weapon_categories,player_weapon_tweakdata
	if weapon_base then 
		player_weapon_id = player_weapon_id or weapon_base.get_name_id and weapon_base:get_name_id() or ""
		player_weapon_tweakdata = tweak_data.weapon[player_weapon_id]
		player_weapon_categories = weapon_base.categories and weapon_base:categories()
	else
		player_weapon_id = player_weapon_id or ""
		player_weapon_tweakdata = tweak_data.weapon[player_weapon_id] or {}
		player_weapon_categories = player_weapon_tweakdata.categories or {}
	end
	
	variant = variant or attack_data.variant
	local unit_alive = unit and alive(unit)
	local base = unit_alive and unit:base()
	local movement = unit_alive and unit:movement()
	local unit_type = base and base._tweak_table
	local is_cop = CopDamage.is_cop(unit_type)
	local unit_anim = unit_alive and unit.anim_data and unit:anim_data()
	local ext_anim = unit_alive and unit:movement() and unit:movement()._ext_anim or {}
	
	local is_friendly_fire = false
	
	local brain = unit_alive and unit:brain()
	
	local friendly_teams = {
		converted_enemy = true,
		neutral1 = true,
		criminal1 = true,
		hacked_turret = false -- meh, i don't care too much about friendly fire on hacked turrets lol
	}
	local unit_team = (brain and brain._logic_data and brain._logic_data.team and brain._logic_data.team.id) or ""
	if friendly_teams[unit_team] or (unit_alive and (CopDamage.is_civilian(unit_type) or managers.enemy:is_civilian(unit))) then 
--		self:log("Killed enemy with team " .. tostring(brain._logic_data.team.id),{color=Color.green})
		is_friendly_fire = true
	end
	
	local player_guns = player:inventory():available_selections()
	local primary_id = player_guns[1].unit:base():get_name_id()
	local secondary_id = player_guns[2].unit:base():get_name_id()

--	local medal_multiplier = 1

	local unit_name = managers.localization:text("noblehud_unitname_" .. tostring(unit_type))
	if not (unit_name and unit_type) or string.find(unit_name,"ERROR") then 
		if unit_team ~= "neutral1" and friendly_teams[unit_team] then 
			unit_name = managers.localization:text("noblehud_unitname__generic_teammate")
		else
			unit_name = managers.localization:text("noblehud_unitname__generic_civilian")
		end
	end
	
	if is_friendly_fire then
		self:ClearKillsCache()
		self:PlayAnnouncerSound("betrayal")
		self:AddKillfeedMessage(string.gsub(managers.localization:text("noblehud_medal_betrayal"),"$1",unit_name),{color_2 = Color.red})
		--no +1 kills for you, you murderer >:(
	else
		if self:IsSkullActive("birthday") and unit_alive and unit:base() then 
			
			if headshot then
				local function spawn_headshot_confetti(effect_name)
					local result = World:effect_manager():spawn({
						effect = Idstring(effect_name or "effects/payday2/particles/impacts/money_impact_pd2"),
						position = movement and movement:m_head_pos() or unit:position() or Vector3()
					})
					if result ~= -1 then 
						return result
					else
						World:effect_manager():spawn({
							effect = Idstring("effects/payday2/particles/impacts/money_impact_pd2"),
							position = movement and movement:m_head_pos() or unit:position() or Vector3()
						})
					end
				end
				spawn_headshot_confetti("effects/payday2/particles/explosions/balloon_pop_red")
				spawn_headshot_confetti("effects/payday2/particles/explosions/balloon_pop_orange")
				spawn_headshot_confetti("effects/payday2/particles/explosions/balloon_pop_green")
				spawn_headshot_confetti("effects/payday2/particles/explosions/balloon_pop_blue")
				spawn_headshot_confetti("effects/payday2/particles/explosions/balloon_pop_purple")
				spawn_headshot_confetti("effects/payday2/particles/explosions/balloon_pop_white")
				local grunt_birthday_path = self._sounds.grunt_birthday
				if grunt_birthday_path then
					XAudio.UnitSource:new(unit,XAudio.Buffer:new(grunt_birthday_path)):set_volume(self:GetSoundVolume())
				end
			end
		end
		
		local my_vehicle = managers.player:get_vehicle() 
		
		if self:IsKillstreakMedalsEnabled() and my_vehicle and my_vehicle.vehicle_unit then 
			local driving_ext = my_vehicle.vehicle_unit:vehicle_driving()
			if driving_ext and driving_ext._seats then 
				if driving_ext._seats.driver then 
					local driver_char = driving_ext._seats.driver.occupant
					if driver_char and (driver_char ~= player) then 
						local driver_id = managers.criminals:character_peer_id_by_unit(driver_char) 
						local driver_peer = driver_id and managers.network:session():peer(driver_id)
						local driver_name = tostring((driver_peer and driver_peer:name()) or managers.localization:text("noblehud_unitname__generic_teammate"))
						self:AddKillfeedMessage(string.gsub(managers.localization:text("noblehud_medal_wheelman_assisted"),"$1",driver_name),{})
					end
				end
			end
		end
	
		if managers.statistics._start_session_from_beginning and managers.statistics._global.killed.total and managers.statistics._global.session.killed.total.count <= 1 and not self.has_done_first_strike then 
			--todo consistency fix
			self:AddMedal("first")
			self.has_done_first_strike = true
		end
		
		if unit_alive then 
			
			local is_revenge = self:IsRevenging(unit)
			if is_revenge then
				self:AddMedal("revenge",nil,{macros = {unit_name}})
			end
			local is_avenger,avenges = self:IsAvenging(unit)
			if is_avenger then
				for _,peer_name in ipairs(avenger) do 
					self:AddMedal("avenger",nil,{macros={peer_name,unit_name}})
				end
			end
			self:UnregisterKiller(unit)
		end
		
		if player:character_damage():_max_armor() > 0 and player:character_damage():health_ratio() <= 0.5 and player:character_damage():get_real_armor() <= 0 then 
			self:KillsCache("close_call",true,true)
		end
		
		if player:character_damage():incapacitated() or player:character_damage():bleed_out() then 
			self:AddMedal("grave")
		end
	
		if movement and movement:rope_unit() then 
			self:AddMedal("pull")
		end
		
		if player_movement and player_movement:zipline_unit() then 
			self:AddMedal("firebird")
		end
		
		local action = movement and movement._active_actions[1]
		
		local action_type = action and action:type()
		if unit_type == "spooc" then
			if action_type == "spooc" then
				if action:is_flying_strike() then
					self:AddMedal("bulltrue")
				elseif not action:has_striken() then
					self:AddMedal("showstopper")
				end
			end
		end
		
		if ext_anim.reload then 
			self:AddMedal("reload_this")
		end
		
		
		local ptd = tweak_data.blackmarket.projectiles[player_weapon_id]
		if ptd and ptd.is_a_grenade then
			self:AwardMedalProgress("spree_grenade","grenade",1)
--			self:AddMedal("spree_grenade",self:KillsCache("grenade",1))
		elseif variant == "bullet" then 
			if headshot then
				if ext_anim.sprint then 
					self:AddMedal("headcase")
				else
					self:AddMedal("headshot")
				end
			end
			local is_sniper,is_shotgun

			if type(player_weapon_categories) == "table" then 
				for _,cat in pairs(player_weapon_categories) do 
					if cat == "shotgun" then 
						is_shotgun = true
					elseif cat == "snp" then 
						is_sniper = true
					end
				end
			end
			
			if is_sniper then 
				if headshot then 
					self:AddMedal("sniper")
				end
				self:AwardMedalProgress("spree_sniper","sniper",1)
--				self:AddMedal("spree_sniper",self:KillsCache("sniper",1))
			end
			if is_shotgun then 
				self:AwardMedalProgress("spree_shotgun","shotgun",1)
--				self:AddMedal("spree_shotgun",self:KillsCache("shotgun",1))	
			end
			

		elseif variant == "melee" then
			local melee_weapon_type
		
			local melee_id = managers.blackmarket:equipped_melee_weapon()
			local melee_data = tweak_data.blackmarket.melee_weapons[melee_id or ""]
			if melee_data then 
				local melee_stats = melee_data.stats
				if melee_stats then
					melee_weapon_type = melee_stats.weapon_type
				end
			end
			
			self:AddMedal("pummel")
				
			local mvec_1 = Vector3()
			local mvec_2 = Vector3()
			mvector3.set(mvec_1, unit:position())
			mvector3.subtract(mvec_1, player:position())
			mvector3.normalize(mvec_1)
			mvector3.set(mvec_2, unit:rotation():y())
			if mvector3.dot(mvec_1, mvec_2) >= 0 then
				self:AddMedal("beatdown")
			end
			if unit:movement():cool() then
				self:AddMedal("assassination")
			end
			
			local melee_spree_type 
			if melee_weapon_type == "blunt" then 
				melee_spree_type = "spree_hammer"
			elseif melee_weapon_type == "sharp" then
				melee_spree_type = "spree_sword"
			end
			
			if melee_spree_type then
				self:AwardMedalProgress(melee_spree_type,"melee",1)
			end
		elseif variant == "graze" then 
			--supercombine kill medal?
		elseif variant == "vehicle" then 
			self:AddMedal("splatter")
			
--			self:AddMedal("spree_splatter",self:KillsCache("vehicle",1))
			self:AwardMedalProgress("spree_splatter","vehicle",1)
		end
		
		if self:KillsCache("last_kill_t") + self:GetMultikillTime() >= t then 
--			self:AddMedal("multikill",self:KillsCache("multi_count",1))
			self:AwardMedalProgress("multikill","multi_count",1)
			
		else
			self:KillsCache("multi_count",1,true)
		end
		
		local spree_count = self:KillsCache("spree_count") + 1
		if self.HUD_VALUES.EASTER_EGG_MEDAL_1_ENABLED then
			if spree_count >= self.HUD_VALUES.EASTER_EGG_MEDAL_1_SPREE_THRESHOLD then
				if math.random() <= self.HUD_VALUES.EASTER_EGG_MEDAL_1_CHANCE then 
					self:AddMedal("trans_rights")
				end
			end
		end
		
		self:AwardMedalProgress("spree_all","spree_count",1)
--		self:AddMedal("spree_all",spree_count)
		self:KillsCache("last_kill_t",t,true)
	end
--	self:TallyScore(attack_data.name or unit_type,unit,medal_multiplier,is_friendly_fire)
end

function HaloAnnouncer:OnTeammateKill(attack_data)
	local player_unit = attack_data and attack_data.attacker_unit or attack_data.player_unit
	if not (player_unit and self:IsKillstreakMedalsEnabled()) then
		return
	end
	
	local enemy_unit = attack_data.unit
--	local assist_timer = self.HUD_VALUES.ASSIST_THRESHOLD_TIMER
	local t = Application:time()
	local assist 
	
	local dmg_ext = alive(enemy_unit) and enemy_unit:character_damage()
	if dmg_ext then
		local last_damage_t = dmg_ext.haloannouncer_last_damage_dealt_t 
		if last_damage_t and (last_damage_t + self.HUD_VALUES.ASSIST_TIMER_THRESHOLD > t) then
			assist = true
		else
			local player_damage_dealt = copdamage.haloannouncer_total_damage_dealt
			local total_health = dmg_ext._HEALTH_INIT or math.huge
			if player_damage_dealt / total_health > self.HUD_VALUES.ASSIST_DAMAGE_PERCENT_THRESHOLD then
				assist = true
	--			self:AddMedal("spree_assist",self:KillsCache("assist_count",1))
			end
		end
	end
	
	local peer_id = alive(player_unit) and managers.criminals:character_peer_id_by_unit(player_unit)
	if peer_id then
		self.has_done_first_strike = true
		local vehicle = managers.player:get_vehicle_for_peer(peer_id)
		local my_vehicle = managers.player:get_vehicle() or {}
		if my_vehicle and my_vehicle.vehicle_unit then
			if vehicle and vehicle.vehicle_unit then 
				if alive(vehicle.vehicle_unit) and alive(my_vehicle.vehicle_unit) then 
					if vehicle.vehicle_unit == my_vehicle.vehicle_unit then
						local peer = managers.network:session():peer(peer_id)
						local peer_name = (peer and peer:name()) or managers.localization:text("noblehud_unitname__generic_teammate")
						if my_vehicle.seat == "driver" then 
							--if player_unit is in your car, give wheelman medal
							self:AddMedal("wheelman",nil,{macros = {peer_name}})
							
							self:AwardMedalProgress("spree_wheelman","vehicle_assist",1)
--							self:AddMedal("spree_wheelman",self:KillsCache("vehicle_assist",1))
						end
					end
				end
			end
		end
	end
	
	if assist then
		self:AwardMedalProgress("spree_assist","assist_count",1)
	end
end


-- Medal Awarding

function HaloAnnouncer:AddMedalFromData(data,category,params)
		--direct reference to table passed here
	local killfeed = self._killfeed_panel
	if not (data and data.icon_xy) then 
--		self:log("ERROR: bad data to AddMedalFromData(" .. tostring(data) .. ")")
		return
	elseif data.disabled then 
--		self:log("Did not add medal " .. tostring(category) .. " (disabled)")
		return
	end
	local delayed_calls = DelayedCalls
	if data.sfx then 
		if data.hold_sfx and not self:IsAnnouncerFranticEnabled() then --for tiered medals, in order to not list every medal tier up to the current spree/multikill 
			delayed_calls:Add(
				"medal_sfx_" .. tostring(category or "medalname"),
				self:GetMultikillTime(),
				function()
					self:PlayAnnouncerSound(data.sfx)
				end
			)
		else		
			self:PlayAnnouncerSound(data.sfx)
		end
	end
	
	if not self:IsKillstreakMedalsEnabled() then 
		return
	end
	
	local name = data.name and managers.localization:text("noblehud_medal_" .. data.name)
	
	if params and params.macros then 
		for i,s in ipairs(params.macros) do 
			name = string.gsub(name,"$" .. i,s)
		end
	end
	
	local hud_values = self.HUD_VALUES
	
	self.num_medals = self.num_medals + 1
	local texture,texture_rect = self:GetMedalIcon(unpack(data.icon_xy))
	local icon_size = hud_values.MEDAL_ICON_SIZE
	local start_x = hud_values.MEDAL_ICON_START_X
	local start_y = hud_values.MEDAL_ICON_START_Y

	local icon = killfeed:bitmap({
		name = "icon_" .. self.num_medals,
		texture = texture,
		texture_rect = texture_rect,
		w = icon_size,
		h = icon_size,
		halign = "grow",
		valign = "grow",
		rotation = hud_values.MEDAL_ICON_START_ANGLE, --upside down, spins half a rotation in its intro animation
		x = start_x,
		y = start_y,
		layer = 1,
		alpha = 1
	})
	
	if self.newest_medal and alive(self.newest_medal) then 
		self:animate_remove_done_cb(self.newest_medal,
			function(o)
				o:set_rotation(0)
				local center_x,center_y = o:center()
				self:animate(o,"animate_killfeed_icon_pulse",nil,hud_values.MEDAL_ICON_ANIMATE_NEW_PULSE_DURATION,icon_size,hud_values.MEDAL_ICON_ANIMATE_NEW_PULSE_SCALE,center_x,center_y)
			end
		)
		table.insert(self.killfeed_icons,1,{start_t = Application:time(),bitmap = self.newest_medal})
	end
	self.newest_medal = icon
	
	local function add_bitmap_to_killfeed (bitmap)
		self.newest_medal = nil
		table.insert(self.killfeed_icons,1,{start_t = Application:time(),bitmap = bitmap})
	end	
	self:animate(icon,"animate_killfeed_icon_twirl",function(o) o:set_rotation(0); self:animate(o,"animate_killfeed_icon_pulse",add_bitmap_to_killfeed,hud_values.MEDAL_ICON_ANIMATE_NEW_PULSE_DURATION,icon_size,hud_values.MEDAL_ICON_ANIMATE_NEW_PULSE_SCALE) end,hud_values.MEDAL_ICON_ANIMATE_NEW_TWIRL_DURATION,hud_values.MEDAL_ICON_ANIMATE_NEW_TWIRL_ANGLE,start_x,start_y)

	local show_medal_messages = self:GetMedalMessageDisplayMode()
	if (show_medal_messages == 1) or (show_medal_messages == 2 and data.show_text) then 
		self:AddKillfeedMessage(name .. (data.suffix or "!"),{font_size = hud_values.KILLFEED_TEXT_FONT_SIZE})
	end
	
	return icon
end

function HaloAnnouncer:AddMedal(category,rank,params) --from name
	local medal_data = self._medal_data[category]
--	self:log("Doing HaloAnnouncer:AddMedal(" .. tostring(category) .. "," .. tostring(rank) .. ")",{color = Color.yellow})

	if rank and medal_data and medal_data[rank] then
		return self:AddMedalFromData(medal_data[rank],category,params)
	elseif medal_data and not rank then 
		return self:AddMedalFromData(medal_data,category,params)
	elseif not (medal_data or rank) then
		self:log("ERROR: HaloAnnouncer:AddMedal(" .. tostring(category) .. "," .. tostring(rank) .. ") (bad medal)",{color = Color.red})
	end
end


-- I/O

function HaloAnnouncer:Load()
	self:LoadSettings()
	self:LoadConfig()
end

function HaloAnnouncer:LoadConfig()
	if self._lip then 
		if SystemFS:exists( Application:nice_path(self._config_path,true) ) then 
			local config_from_ini = self._lip.load(self._config_path)
			if config_from_ini and config_from_ini.Config then 
				for k,v in pairs(config_from_ini.Config) do
					self.HUD_VALUES[k] = v
				end
			end
		end
	end
end

function HaloAnnouncer:LoadSettings()
	local file = io.open(self._save_path, "r")
	if file then
		for k, v in pairs(json.decode(file:read("*all"))) do
			self.settings[k] = v
		end
	else
		self:SaveSettings()
	end
end

function HaloAnnouncer:SaveSettings()
	local file = io.open(self._save_path,"w+")
	if file then
		file:write(json.encode(self.settings))
		file:close()
	end
end

Hooks:Add("MenuManagerInitialize", "haloannouncer_initmenu", function(menu_manager)
	HaloAnnouncer:Setup()
	
	MenuCallbackHandler.callback_haloannouncer_set_hud_compatibility_enabled = function(self,item)
		HaloAnnouncer.settings.hud_compatibility_mode = tonumber(item:value())
		HaloAnnouncer:SaveSettings()
	end
	
	MenuCallbackHandler.callback_haloannouncer_set_sounds_volume = function(self,item)
		HaloAnnouncer.settings.sound_volume = tonumber(item:value())
		HaloAnnouncer:SaveSettings()
	end
	
	MenuCallbackHandler.callback_haloannouncer_testvolume = function(self,item)
		if XAudio then
			local prev_source = HaloAnnouncer._menu_source
			if prev_source then
				 if not prev_source:is_closed() then
					prev_source:set_volume(0)
					prev_source:close()
				 end
				prev_source = nil
			end
			local new_sound_id = HaloAnnouncer._all_sounds[math.random(#HaloAnnouncer._all_sounds)]
			if new_sound_id then
				local new_source = XAudio.Source:new(XAudio.Buffer:new(new_sound_id))
				new_source:set_volume(HaloAnnouncer:GetSoundVolume())
				HaloAnnouncer._menu_source = new_source
			end
		end
	end
	
	MenuCallbackHandler.callback_haloannouncer_set_sounds_enabled = function(self,item)
		HaloAnnouncer.settings.announcer_sounds_enabled = item:value() == "on"
		HaloAnnouncer:SaveSettings()
	end
	
	MenuCallbackHandler.callback_haloannouncer_set_sounds_frantic_enabled = function(self,item)
		HaloAnnouncer.settings.announcer_frantic_enabled = item:value() == "on"
		HaloAnnouncer:SaveSettings()
	end
	
	MenuCallbackHandler.callback_haloannouncer_set_medals_enabled = function(self,item)
		HaloAnnouncer.settings.killstreak_medals_enabled = item:value() == "on"
		HaloAnnouncer:SaveSettings()
	end
	MenuCallbackHandler.callback_haloannouncer_set_killstreak_loop_enabled = function(self,item)
		HaloAnnouncer.settings.killstreak_loop_enabled = item:value() == "on"
		HaloAnnouncer:SaveSettings()
	end
	
	MenuCallbackHandler.callback_haloannouncer_killfeed_medal_message_display_mode = function(self,item)
		HaloAnnouncer.settings.killfeed_medal_message_display_mode = tonumber(item:value())
		HaloAnnouncer:SaveSettings()
	end
	
	MenuCallbackHandler.callback_haloannouncer_set_grunt_birthday_mode = function(self,item)
		HaloAnnouncer.settings.grunt_birthday_mode = tonumber(item:value())
		HaloAnnouncer:SaveSettings()
		
		HaloAnnouncer:CheckActiveSkulls()
	end
	
	
	
	MenuHelper:LoadFromJsonFile(HaloAnnouncer._menu_path, HaloAnnouncer, HaloAnnouncer.settings)
	
	HaloAnnouncer:Load()
end)


Hooks:Add("LocalizationManagerPostInit", "haloannouncer_addlocalization", function( loc )
	if not BeardLib then
		loc:load_localization_file(HaloAnnouncer._default_localization_path)
	end
end)

